/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : May, 1997                                                      */
/* File Name : Date.cc                                                   */
/*************************************************************************/
/*************************************************************************/

#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include <strstream.h>
#include "Date.h"

/*
//
*/

Date::Date()
{  hour = -1;
   minute = -1;
   second = -1;
}// end of  constructor

/*
//
*/

Date::Date(char *_str)
{  istrstream inStr(_str);
   char buf[80];
   inStr.getline(buf,80,',');
   if(buf[0]=='M') aday = Monday;
   else if(buf[0]=='W') aday=Wednesday;
   else if(buf[0]=='F') aday=Friday;
   else if(buf[0]=='S' && buf[1]=='t') aday=Saturday;
   else if(buf[0]=='S' && buf[1]=='u') aday=Sunday;
   else if(buf[0]=='T' && buf[1]=='u') aday=Tuesday;
   else if(buf[0]=='T' && buf[1]=='h') aday=Thursday;
   else aday = Monday;

   inStr.getline(buf,80,':');
   hour = (atoi(buf)%60);
   inStr.get(buf,80);
   minute = atoi(buf)%60;
   second = 0;

}// end of constructor

/*
//
*/

Date::Date(Day _aday, unsigned _hour, unsigned _minute, unsigned _second)
{    aday = _aday;
     hour = (_hour%24);
   minute = (_minute%60);
   second = (_second%60);
}// end of constructor

/*
//
*/

Date::Date(const Date& RHS)
{    aday = RHS.aday;
     hour = RHS.hour;
   minute = RHS.minute;
   second = RHS.second;
}// end of COPY constructor

/*
//
*/

Date::~Date() {}

/*
//
*/

Day Date::getDay() const { return aday;}

/*
//
*/

unsigned Date::getHour() const { return hour; }

/*
//
*/

unsigned Date::getMinute() const { return minute; }

/*
//
*/

unsigned Date::getSecond() const { return second; }

/*
//  Returns the difference between two date object in terms of minutes.
*/

Date::operator-(const Date& RHS) 
{  int ret = (aday-RHS.aday) * 24 * 60;
   ret += (hour - RHS.hour) * 60;
   ret += (minute - RHS.minute);
   //cout << (*this) << " - " << RHS << " = " << ret << endl;
   return ret;
}// end of operator-()

/*
//
*/

Date::operator<(const Date& RHS) 
{  return ((*this)-RHS<0?1:0);
}// end of operator<()

/*
//
*/

Date::operator>(const Date& RHS) 
{  return ((*this)-RHS>0?1:0);
}// end of operator>()

/*
//
*/

Date Date::operator=(const Date& RHS) 
{    aday = RHS.aday;
     hour = RHS.hour;
   minute = RHS.minute;
   second = RHS.second;
   return (*this);
}// end of operator=()

/*
//
*/

Date::operator==(const Date& RHS) 
{  int ret=1;
   ret = ret && ( aday == RHS.aday);
   ret = ret && ( hour == RHS.hour);
   ret = ret && ( minute == RHS.minute);
   ret = ret && ( second == RHS.second);
   return ret;
}// end of operator==()

/*
//
*/

ostream & operator<<(ostream& os, const Date& RHS)
{  char DayName[7][5] = { "M", "Tu", "W", "Th", "F", "St", "Su" };
   os << setw(2) << DayName[RHS.aday] << "," ;
   char oldfill = os.fill('0');
   os << setw(2) << RHS.hour << ":" << setw(2) <<  RHS.minute << " "; 
   os.fill(oldfill);
   return os;
}// end of operator <<()

